#include <amxmod> 
#include <Vexd_Utilities> 
#include <superheromod> 

// GLOBAL VARIABLES 
new gHeroName[]="Splask" 
new gHassplaskPower[SH_MAXSLOTS+1] 
//---------------------------------------------------------------------------------------------- 
public plugin_init() 
{ 
    // Plugin Info 
    register_cvar("splask_level", "10") 
    register_cvar("splask_galilmult", "1.5") 
    shCreateHero(gHeroName, "New Super Kool Gun! With More Damage", "New Super Kool Gun! With More Damage", false, "splask_level") 
    register_srvcmd("splask_init", "splask_init") 
    shRegHeroInit(gHeroName, "splask_init") 
    register_event("ResetHUD", "newSpawn", "b") 
    register_event("Damage", "splask_damage", "b") 
    register_event("CurWeapon", "weaponChange", "be", "1=1") 
    shSetShieldRestrict(gHeroName) 
} 
//---------------------------------------------------------------------------------------------- 
public plugin_precache() 
{ 
    precache_model("models/shmod/v_splask.mdl") 
    precache_model("models/shmod/p_splask.mdl") 
} 
//---------------------------------------------------------------------------------------------- 
public splask_init() 
{ 
    new temp[6] 
    read_argv(1,temp,5) 
    new id = str_to_num(temp) 

    read_argv(2,temp,5) 
    new hasPowers = str_to_num(temp) 

    gHassplaskPower[id] = (hasPowers != 0) 

    shResetShield(id) 

    if ( !is_user_alive(id) ) return 

    if ( gHassplaskPower[id] ) { 
        splask_weapons(id) 
        switchmodel(id) 
    } 
    else { 
        engclient_cmd(id, "drop", "weapon_galil") 
    } 
} 
//----------------------------------------------------------------------------------------------- 
public splask_weapons(id) 
{ 
    if ( is_user_alive(id) && shModActive() ) { 
        shGiveWeapon(id, "weapon_galil") 
    } 
} 
//----------------------------------------------------------------------------------------------- 
public newSpawn(id) 
{ 
    if ( gHassplaskPower[id] && is_user_alive(id) && shModActive() ) { 
        set_task(0.1, "splask_weapons", id) 

        new clip, ammo, wpnid = get_user_weapon(id, clip, ammo) 
        if ( wpnid != CSW_GALIL && wpnid > 0 ) { 
            new wpn[32] 
            get_weaponname(wpnid, wpn, 31) 
            engclient_cmd(id, wpn) 
        } 
    } 
} 
//----------------------------------------------------------------------------------------------- 
public switchmodel(id) 
{ 
    if ( !is_user_alive(id) || !gHassplaskPower[id] ) return 

    new clip, ammo, wpnid = get_user_weapon(id, clip, ammo) 
    if ( wpnid == CSW_GALIL ) { 
        set_pev(id, pev_viewmodel2, "models/shmod/v_splask.mdl") 
        set_pev(id, pev_weaponmodel2, "models/shmod/p_splask.mdl") 
    } 
} 
//---------------------------------------------------------------------------------------------- 
public weaponChange(id) 
{ 
    if ( !gHassplaskPower[id] || !shModActive() ) return 

    new wpnid = read_data(2) 
    new clip = read_data(3) 

    if ( wpnid != CSW_GALIL ) return 

    switchmodel(id) 

    if ( clip == 0 ) { 
        shReloadAmmo(id) 
    } 
} 
//----------------------------------------------------------------------------------------------- 
public splask_damage(id) 
{ 
    if ( !shModActive() || !is_user_alive(id) ) return 

    new damage = read_data(2) 
    new weapon, bodypart, attacker = get_user_attacker(id, weapon, bodypart) 
    new headshot = bodypart == 1 ? 1 : 0 

    if ( attacker <= 0 || attacker > SH_MAXSLOTS ) return 

    if ( gHassplaskPower[attacker] && weapon == CSW_GALIL && is_user_alive(id) ) { 
        new extraDamage = floatround(damage * get_cvar_float("splask_galilmult") - damage) 
        if (extraDamage > 0) shExtraDamage(id, attacker, extraDamage, "galil", headshot) 
    } 
} 
//-----------------------------------------------------------------------------------------------  